Submit | All submissions | Best solutions | Back to list |
PIE - Pie |
My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.
My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.
What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.
Input
One line with a positive integer: the number of test cases. Then for each test case:
- One line with two integers N and F with 1 ≤ N, F ≤ 10000: the number of pies and the number of friends.
- One line with N integers ri with 1 ≤ ri ≤ 10000: the radii of the pies.
Output
For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10-3.
Example
Input: 3 3 3 4 3 3 1 24 5 10 5 1 4 2 3 4 5 6 5 4 2 Output: 25.1327 3.1416 50.2655
Added by: | overwise |
Date: | 2007-10-02 |
Time limit: | 1s |
Source limit: | 50000B |
Memory limit: | 1536MB |
Cluster: | Cube (Intel G860) |
Languages: | All except: ERL JS-RHINO NODEJS PERL6 VB.NET |
Resource: | ACM ICPC NWERC 2006 |
hide comments
|
|||||||||
2021-07-10 14:24:17
Don't use the standard while loop in binary search, you can't compare doubles here |
|||||||||
2021-06-09 13:26:13
USE LONG DOUBLE AND SET PRECISION TO DISPLAY UPTO 4 PLACES. CHECK THAT TEST CASES MATCH EXACTLY ELSE YOU LL GET A WA |
|||||||||
2021-04-20 16:27:31
I am applying binary search on the area possible and finding the total pieces possible from it but it is giving WA |
|||||||||
2020-10-01 06:33:01
Binary Search in Monotonic function. Cost me 5 WA. Use pi=3.14159265358979323846264338327950. long double, fixed, setprecision! Last edit: 2020-10-01 06:46:49 |
|||||||||
2020-06-12 17:51:40
use fixed and setprecision for ans. cost me 5 WA due to decimals. |
|||||||||
2020-06-03 18:02:35
can someone explain the test case. it looks like the first two parts of it are not correct |
|||||||||
2020-06-01 22:55:38
If not clicking, try reading about binary search on monotonic functions. |
|||||||||
2020-03-10 13:19:01
Problem where you need to think against the general opinion that you get on the first go. |
|||||||||
2020-01-15 11:06:26
Nice problem!! Involves binary search on floating values. |
|||||||||
2019-04-04 14:41:46
A nice problem. Taught the concept of binary search on a monotonic function. |